// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from data_tamer_msgs:msg/Snapshot.idl
// generated code does not contain a copyright notice
#include "data_tamer_msgs/msg/detail/snapshot__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `active_mask`
// Member `payload`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
data_tamer_msgs__msg__Snapshot__init(data_tamer_msgs__msg__Snapshot * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp_nsec
  // schema_hash
  // active_mask
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->active_mask, 0)) {
    data_tamer_msgs__msg__Snapshot__fini(msg);
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->payload, 0)) {
    data_tamer_msgs__msg__Snapshot__fini(msg);
    return false;
  }
  return true;
}

void
data_tamer_msgs__msg__Snapshot__fini(data_tamer_msgs__msg__Snapshot * msg)
{
  if (!msg) {
    return;
  }
  // timestamp_nsec
  // schema_hash
  // active_mask
  rosidl_runtime_c__uint8__Sequence__fini(&msg->active_mask);
  // payload
  rosidl_runtime_c__uint8__Sequence__fini(&msg->payload);
}

bool
data_tamer_msgs__msg__Snapshot__are_equal(const data_tamer_msgs__msg__Snapshot * lhs, const data_tamer_msgs__msg__Snapshot * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp_nsec
  if (lhs->timestamp_nsec != rhs->timestamp_nsec) {
    return false;
  }
  // schema_hash
  if (lhs->schema_hash != rhs->schema_hash) {
    return false;
  }
  // active_mask
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->active_mask), &(rhs->active_mask)))
  {
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->payload), &(rhs->payload)))
  {
    return false;
  }
  return true;
}

bool
data_tamer_msgs__msg__Snapshot__copy(
  const data_tamer_msgs__msg__Snapshot * input,
  data_tamer_msgs__msg__Snapshot * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp_nsec
  output->timestamp_nsec = input->timestamp_nsec;
  // schema_hash
  output->schema_hash = input->schema_hash;
  // active_mask
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->active_mask), &(output->active_mask)))
  {
    return false;
  }
  // payload
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->payload), &(output->payload)))
  {
    return false;
  }
  return true;
}

data_tamer_msgs__msg__Snapshot *
data_tamer_msgs__msg__Snapshot__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Snapshot * msg = (data_tamer_msgs__msg__Snapshot *)allocator.allocate(sizeof(data_tamer_msgs__msg__Snapshot), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(data_tamer_msgs__msg__Snapshot));
  bool success = data_tamer_msgs__msg__Snapshot__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
data_tamer_msgs__msg__Snapshot__destroy(data_tamer_msgs__msg__Snapshot * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    data_tamer_msgs__msg__Snapshot__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
data_tamer_msgs__msg__Snapshot__Sequence__init(data_tamer_msgs__msg__Snapshot__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Snapshot * data = NULL;

  if (size) {
    data = (data_tamer_msgs__msg__Snapshot *)allocator.zero_allocate(size, sizeof(data_tamer_msgs__msg__Snapshot), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = data_tamer_msgs__msg__Snapshot__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        data_tamer_msgs__msg__Snapshot__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
data_tamer_msgs__msg__Snapshot__Sequence__fini(data_tamer_msgs__msg__Snapshot__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      data_tamer_msgs__msg__Snapshot__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

data_tamer_msgs__msg__Snapshot__Sequence *
data_tamer_msgs__msg__Snapshot__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  data_tamer_msgs__msg__Snapshot__Sequence * array = (data_tamer_msgs__msg__Snapshot__Sequence *)allocator.allocate(sizeof(data_tamer_msgs__msg__Snapshot__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = data_tamer_msgs__msg__Snapshot__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
data_tamer_msgs__msg__Snapshot__Sequence__destroy(data_tamer_msgs__msg__Snapshot__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    data_tamer_msgs__msg__Snapshot__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
data_tamer_msgs__msg__Snapshot__Sequence__are_equal(const data_tamer_msgs__msg__Snapshot__Sequence * lhs, const data_tamer_msgs__msg__Snapshot__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!data_tamer_msgs__msg__Snapshot__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
data_tamer_msgs__msg__Snapshot__Sequence__copy(
  const data_tamer_msgs__msg__Snapshot__Sequence * input,
  data_tamer_msgs__msg__Snapshot__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(data_tamer_msgs__msg__Snapshot);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    data_tamer_msgs__msg__Snapshot * data =
      (data_tamer_msgs__msg__Snapshot *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!data_tamer_msgs__msg__Snapshot__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          data_tamer_msgs__msg__Snapshot__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!data_tamer_msgs__msg__Snapshot__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
